﻿using System;
using System.IO;
using System.Linq;
using FaragostarWebServiceSample.FaraGostarAuthService;
using FaragostarWebServiceSample.FaraGostarCustomerService;

namespace NewLetter
{
    internal class Program
    {
        private static void Main()
        {
            LetterDetailModel letterDetailModel;
            //Connect The WebService With using that Diposible Memory After Finishing Job.
            using (var customerServiceClient = new CustomerServiceClient())
            using (var authServiceClient = new AuthServiceClient())
            {
                //Define Username 
                const string username = "admin";
                //Fill Model 
                var userModel = new CredentialModel
                {
                    Username = username,
                    Password = "1"
                };

                //Define Guid That Get A FaraGostar Company
                var applicationGuid = new Guid("8A5D7167-E0F9-4C3B-BAA6-EB736A707BAD");
                var ticketModel = authServiceClient.SignIn(applicationGuid, userModel);
                //Get ticketId
                var ticket = ticketModel.SecureTicketId;
                var employeePositonModel = customerServiceClient.GetUserEmployeePosition(ticket, username);
                var employeePositionModel = customerServiceClient.GetUserEmployeePosition(ticket, username);

                //GetPositionCode
                var employeePositionCode =
                    employeePositionModel.SingleOrDefault(x => x.IsDefault)?.EmployeePositionCode;

                //Instance Of LetterDetailModel and Fill it
                letterDetailModel = new LetterDetailModel
                {
                    Letter = new LetterModel
                    {
                        CreateDate = DateTime.Now,
                        Description = "Desc",
                        Subject = "API Subject is ",
                        LetterSenderCode = employeePositonModel.First().EmployeePositionId.ToString(),
                        LetterDraftTypeKind = LetterDraftTypeKinds.FileEditor,
                        InOutTypeKind = LetterInOutTypeKinds.External,
                        SecretariatToSecretariatFormatId = 1,
                        ReplyToCreator = true,
                        EmployeePositionIdSender = employeePositonModel.First().EmployeePositionId
                    },
                    SyncBodies = true,
                    SyncFirstReceiver = true
                };
                //Fill the Model For Attachment 
                var path = @"C:\File.jpg";
                var fileAttachment = Directory.GetFiles(path);

                letterDetailModel.Attachments = new LetterAttachmentModel[1];
                var attIndex = 0;
                foreach (var attch in fileAttachment)
                {
                    //Convert File To Byte And Fill Model Like Sample
                    var bytes = File.ReadAllBytes(attch);
                    var fileInfo = new FileInfo(attch);

                    letterDetailModel.Attachments[attIndex++] =
                        new LetterAttachmentModel
                        {
                            FileName = fileInfo.Name,
                            Title = fileInfo.Name,
                            FileExtension = fileInfo.Extension,
                            FileImage = bytes,
                            FileLength = (int) fileInfo.Length,
                            IsOtherLetterAttachment = true,
                            Description = "Description"
                        };
                }
                //Fill The ReceiverModel
                LetterReceiverModel[] letterReceivers =
                {
                    new LetterReceiverModel
                    {
                        EmployeePositionId = 3,
                        CopyTypeKind = ReferCopyTypeKinds.Original,
                        Code = "3"
                    },
                    new LetterReceiverModel
                    {
                        EmployeePositionId = 1,
                        CopyTypeKind = ReferCopyTypeKinds.Original,
                        Code = "1"
                    }
                };


                //call Method For updatge By Model


                var ticketId = ticketModel.SecureTicketId;
            }
        }
    }
}