﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace ProcessMakerNewCase
{
    public class CaseModel
    {
       
        public async Task<string> CreateNewCase(NewCaseparameter param, string token)
        {

            string result = string.Empty;
            try
            {
                token = await Login();

                var restApiParameter = JsonConvert.SerializeObject(param);

                var apiUrl = "/api/1.0/workflow/cases";

                result = await CallRestapi(apiUrl, restApiParameter, token, "POST");

                await RouteCase(result, token);  
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
            return result;
        }



        public async Task<string> Route_only(NewCaseparameter param, string token,string APP_uid,string APP_number)
        {

            string result = string.Empty;
            try
            {
                token = await Login();

                var restApiParameter = JsonConvert.SerializeObject(param);

               // var apiUrl = "/api/1.0/workflow/cases";

                result = "{\"app_uid\":\""+APP_uid+"\",\"app_number\":"+APP_number+"}";    ///

                await RouteCase(result, token);
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
            return result;
        }






        public async Task<string> Login()
        {
            try
            {
                var param = new Loginparameter();
                
                var restApiParameter = JsonConvert.SerializeObject(param);

                var apiUrl = "/workflow/oauth2/token";

                var result = await CallRestapi(apiUrl, restApiParameter,"",  "POST");

                Tokens token = JsonConvert.DeserializeObject<Tokens>(result);
                
                return token.access_token;

            }
            catch (Exception ex)
            {
                Tokens token = new Tokens();
                return "";
            }
        }


        public async Task RouteCase(string appUid, string token)
        {
            try
            {
                if (!string.IsNullOrWhiteSpace(appUid))
                {
                    var convert = JsonConvert.DeserializeObject<CaseResult>(appUid).app_uid;
                    var apiUrl = GenerateRestUrl(convert, "route-case");
                    await CallRestapi(apiUrl, string.Empty, token, "PUT");
                }
                else
                {
                    throw new Exception("خطا در انجام عملیات");
                }

            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
        }

        public async Task<string> CallRestapi(string apiUrl, string restApiParameter, string accessToken, string type)
        {
            HttpResponseMessage result = new HttpResponseMessage();
            
            
            using (var client = new HttpClient())
            {
                try
                {
                    client.BaseAddress = new Uri(ConfigurationManager.AppSettings["baseUrl"]);
                    client.DefaultRequestHeaders.Clear();
                    if (accessToken != "")
                    {
                        client.DefaultRequestHeaders.Authorization =
                            new AuthenticationHeaderValue("Bearer", accessToken);
                    }

                    var content = new StringContent(restApiParameter, Encoding.UTF8, "application/json");
                    switch (type)
                    {
                        case "PUT":
                            result = client.PutAsync(apiUrl, content).Result;
                            break;
                        case "POST":
                            result = client.PostAsync(apiUrl, content).Result;
                            break;

                    }
                    if (result.IsSuccessStatusCode)
                    {
                        var empResponse = await result.Content.ReadAsStringAsync();
                        if (empResponse != "") {
                          // app_numx = empResponse;//hooman
                        }
                        
                        return empResponse;
                        

                       

                    }
                }
                catch (Exception ex)
                {
                    throw new Exception(ex.Message);
                }
            }
            return string.Empty;
        }

        private string GenerateRestUrl(string appUid, string restType)
        {
            return string.Format("/api/1.0/{0}/cases/{1}/{2}", "workflow", appUid, restType);
        }
    }

    public class NewCaseparameter
    {
        public string pro_uid { get; set; }
        public string tas_uid { get; set; }
        public List<Variable> variables { get; set; }


    }
    public class Loginparameter
    {

    public Loginparameter ()
    {
        grant_type = "password";   
        scope = "*";
        client_id = "SQVJKDRVNZCOSVKAZZMDACQLWKRVDRAV";
        client_secret = "8848266605d997779cd1568000814432";
        username = "admin";
        password = "1";


    }
        public string grant_type  { get; set; }
        public string scope { get; set; }
        public string client_id { get; set; }
        public string client_secret { get; set; }
        public string username { get; set; }
        public string password { get; set; }


    }
    public class Variable
    {
        public string tarikh { get; set; }
        public string vahed { get; set; }
        public string name { get; set; }
        public string family { get; set; }
        public string kalaname { get; set; }
        public string mojudi { get; set; }
        public string id { get; set; }
    }
    public class CaseResult
    {
        public string app_uid { get; set; }
        public string app_number { get; set; }
    }

    public class Tokens
    {
        public string access_token { get; set; }

    }
        
}
