<?php

// header detail setting
$headers = array(
    "Content-type: application/soap+xml; charset=utf-8",
    "Accept: text/xml",
    "Cache-Control: no-cache",
    "Pragma: no-cache",
    //"SOAPAction: ".$soapUrl,
    //"Content-length: " . strlen($xml_post_string)
);

function getTicketId($response)
{
    // Get SecureTicketId from XML response
    $start_index = strpos($response, "<b:SecureTicketId>") + strlen("<b:SecureTicketId>");
    $end_index = strpos($response, "</b:SecureTicketId>");
    $secureTicketId = substr($response, $start_index, $end_index - $start_index);

    // Get TicketId from XML response
    $start_index = strpos($response, "<b:TicketId>") + strlen("<b:TicketId>");
    $end_index = strpos($response, "</b:TicketId>");
    $ticketId = substr($response, $start_index, $end_index - $start_index);

    return array($secureTicketId, $ticketId);
}

function getSignInXSD($guid, $username, $password)
{
    global $SignIn_XSD_Source_path;
    libxml_disable_entity_loader(false);

    // Open template
    $doc = new DOMDocument();
    $doc->load("C:\SignIn_XSD_Source.xml");

    $doc->getElementsByTagName("applicationGuid")->item(0)->nodeValue = $guid;

    $doc->getElementsByTagName("Password")->item(0)->nodeValue = $password;

    $doc->getElementsByTagName("Username")->item(0)->nodeValue = $username;

    return $doc->saveXML();
}

function getSignOutXSD($secureTicketId, $ticketId)
{
    global $SignIn_XSD_Source_path;
    libxml_disable_entity_loader(false);

    // Open template
    $doc = new DOMDocument();
    $doc->load("C:/SignOut_XSD_Source.xml");

    $doc->getElementsByTagName("SecureTicketId")->item(0)->nodeValue = $secureTicketId;

    $doc->getElementsByTagName("TicketId")->item(0)->nodeValue = $ticketId;

    return $doc->saveXML();
}

function getSendLetterXSD($secureTicketId, $guid, $subject, $contactPositionIdSender, $contactNameSender,
                          $employeePositionId, $fileImage, $secretariatId, $employeePositionSignatureId,
                          $secretariatFormatId, $secretariatToSecretariatFormatId)
{
//    global $SendLetter_XSD_Source_path;

    // Open template
    $doc = new DOMDocument();
    $doc->load('C:\SendLetter_XSD_Source.xml');

    $doc->getElementsByTagName("ticket")->item(0)->nodeValue = $secureTicketId;
    $doc->getElementsByTagName("ApplicationGuid")->item(0)->nodeValue = $guid;
    $doc->getElementsByTagName("Subject")->item(0)->nodeValue = $subject;

    // Sender

    $doc->getElementsByTagName("ContactPositionIdSender")->item(0)->nodeValue = $contactPositionIdSender;
    $doc->getElementsByTagName("EmployeePositionIdSender")->item(0)->nodeValue = $contactPositionIdSender;
    $doc->getElementsByTagName("ContactNameSender")->item(0)->nodeValue = $contactNameSender;

    // Receiver
    $doc->getElementsByTagName("EmployeePositionId")->item(1)->nodeValue = $employeePositionId;

    // Body
    $doc->getElementsByTagName("FileImage")->item(0)->nodeValue = base64_encode($fileImage);

    // SecretariatId
    $doc->getElementsByTagName("SecretariatId")->item(0)->nodeValue = $secretariatId;

    // EmployeePositionSignature
    $doc->getElementsByTagName("EmployeePositionSignatureId")->item(0)->nodeValue =
        $employeePositionSignatureId;

    // SecretariatFormatId
    $doc->getElementsByTagName("SecretariatFormatId")->item(0)->nodeValue = $secretariatFormatId;

    // SecretariatToSecretariatFormatId
    $doc->getElementsByTagName("SecretariatToSecretariatFormatId")->item(0)->nodeValue =
        $secretariatToSecretariatFormatId;

    return $doc->saveXML();
}

function initiate_curl($ch, $soapUrl, $xml_post_string, $headers)
{
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
    curl_setopt($ch, CURLOPT_URL, $soapUrl);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_ANY);
    curl_setopt($ch, CURLOPT_TIMEOUT, 10);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $xml_post_string); // the SOAP request
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
}

function SignIn($guid, $username, $password, $automation_url) {
//    global  $automation_url, $headers;

    $headers = array(
        "Content-type: application/soap+xml; charset=utf-8",
        "Accept: text/xml",
        "Cache-Control: no-cache",
        "Pragma: no-cache",
        //"SOAPAction: ".$soapUrl,
        //"Content-length: " . strlen($xml_post_string)
    );

    // Create Web Service URL by Default Web Service Address
    $soapUrl = $automation_url."/Services/AuthService.svc";

    // Create SignIn xml
    $xml_post_string = getSignInXSD($guid, $username, $password);

    // Initiate and call web service
    $ch = curl_init();
    initiate_curl($ch, $soapUrl, $xml_post_string, $headers);
    $response = curl_exec($ch);
    curl_close($ch);

    // Get and return secureTicketId from respond
    list($secureTicketId, $ticketId) = getTicketId($response);
    return array($secureTicketId, $ticketId);
}

function SignOut($secureTicketId, $ticketId, $automation_url) {
//    global  $automation_url, $headers;

    $headers = array(
        "Content-type: application/soap+xml; charset=utf-8",
        "Accept: text/xml",
        "Cache-Control: no-cache",
        "Pragma: no-cache",
        //"SOAPAction: ".$soapUrl,
        //"Content-length: " . strlen($xml_post_string)
    );

    // Create Web Service URL by Default Web Service Address
    $soapUrl = $automation_url."/Services/AuthService.svc";

    // Create SignIn xml
    $xml_post_string = getSignOutXSD($secureTicketId, $ticketId);

    // Initiate and call web service
    $ch = curl_init();
    initiate_curl($ch, $soapUrl, $xml_post_string, $headers);
    $response = curl_exec($ch);
    curl_close($ch);

    return $response;
}

function SendLetter_ws($xml_post_string, $automation_url) {

//    global  $automation_url, $headers;
    $headers = array(
        "Content-type: application/soap+xml; charset=utf-8",
        "Accept: text/xml",
        "Cache-Control: no-cache",
        "Pragma: no-cache",
        //"SOAPAction: ".$soapUrl,
        //"Content-length: " . strlen($xml_post_string)
    );

    // Create Web Service URL by Default Web Service Address
    $soapUrl = $automation_url."/Services/CustomerService.svc";

    // Initiate and call web service
    $ch = curl_init();
    initiate_curl($ch, $soapUrl, $xml_post_string, $headers);
    $response = curl_exec($ch);
    curl_close($ch);
    return $response;

}

function SendLetter($subject, $username, $password, $automation_url,
                    $guid, $contactPositionIdSender,
                    $contactNameSender, $employeePositionId, $fileImage, $secretariatId, $employeePositionSignatureId,
                    $secretariatFormatId, $secretariatToSecretariatFormatId){

    $headers = array(
        "Content-type: application/soap+xml; charset=utf-8",
        "Accept: text/xml",
        "Cache-Control: no-cache",
        "Pragma: no-cache",
        //"SOAPAction: ".$soapUrl,
        //"Content-length: " . strlen($xml_post_string)
    );

    // Create new ticket id
    list($secureTicketId, $ticketId) = SignIn($guid, $username, $password, $automation_url);

    // Create Web Service URL by Default Web Service Address
    $soapUrl = $automation_url."/Services/CustomerService.svc";

    // Create SignIn xml
    $xml_post_string = getSendLetterXSD($secureTicketId, $guid, $subject, $contactPositionIdSender, $contactNameSender,
        $employeePositionId, $fileImage, $secretariatId, $employeePositionSignatureId, $secretariatFormatId,
        $secretariatToSecretariatFormatId);

    // Call Send Letter Web service
    $response = SendLetter_ws($xml_post_string, $automation_url);

    // SignOut login user
    SignOut($secureTicketId, $ticketId, $automation_url);

    return $response;
}

/*

$guid = "c22d69e7-6595-42fc-8de6-e7781ebafbf0";
$username = "a-admin";
$password = '1';
$automation_url="http://192.168.0.74";

$contactPositionIdSender=@@Sender;
$contactNameSender=@@Sender_label;
$employeePositionId=@@FirstReceiver;
$secretariatId = @@Secretariat;
$employeePositionSignatureId = @@EmployeePositionSignature;
$secretariatFormatId = @@SecretariatFormat;
$secretariatToSecretariatFormatId = @@SecretariatToSecretariatFormat;

$subject = @@Subject;
$fileImage=@@Body;


// Test Part

$guid = "c22d69e7-6595-42fc-8de6-e7781ebafbf0";
$username = "a-admin";
$password = '1';
$automation_url="http://192.168.0.74";

$contactPositionIdSender='1';
$contactNameSender="...";
$employeePositionId='1';
$secretariatId = 1;
$employeePositionSignatureId = 4;
$secretariatFormatId = 1;
$secretariatToSecretariatFormatId = 1;

$subject = "Most Important News";
$fileImage="Faragostar is google of iran!";

echo SendLetter($subject, $username, $password, $automation_url,
    $guid, $contactPositionIdSender,
    $contactNameSender, $employeePositionId, $fileImage, $secretariatId, $employeePositionSignatureId,
    $secretariatFormatId, $secretariatToSecretariatFormatId);
//echo SignIn($guid, $username, $password, $automation_url);


*/